<%@ page import='java.io.*' %>
<%@ page import='java.lang.StringBuffer' %>
<%@ page import='java.net.*' %>
<%@ page import='java.util.*' %>
<%!
    /**
    *  This JSP will load an Azureus stats XML and present the information
    * in an easier to read HTML table. I wrote this for myself but figured
    * someone else might have a use for it too, so here it is.
    *
    * This file is released as freeware. Do with it as you please. If you modify
    * it or use it as the basis for something else, I wouldn't mind a nod in your
    * credits, but it's not absolutely necessary. If you make any changes you
    * want to share with others, you can email me and I'll add in the changes
    * and give you credit here
    *
    * No warranty expressed or implied. Use this at your own risk.
    * Azureus can be found at http://azureus.sourceforge.net
    *
    * The latest version of this file can always be found at
    * http://azstats.pipasoft.com
    * Author: Brian Pipa azstats@pipasoft.com
    *
    * This mostly written while watching the NCSU vs VA Tech football game
    * (GO PACK!) on 9/25/2004
    **/

    /**
    * change this line to point to an Azueus XML file
    * this can either be on the net (ftp or http) or on your local drive
    * (the same computer where this JSP sits)
    * for local files, make sure you double-slash backslashes
    *(or use singles forward slashes instead)
    **/
    //CHANGE THIS
    String inputFile = "SET THIS TO A VALID AZUREUS STATS FILE";
    //examples below
    //String inputFile = "C:\\java\\SERVLETENGINES\\resin-3.0.1-beta\\webapps\\azstats\\Azureus_Stats.xml";
    //String inputFile = "http://pipasoft.com/Azureus_Stats.xml";
    //String inputFile = "http://kwazar.free.fr/Azureus_Stats.xml";
%>

<html>
<!-- Feel free to change this line and use any stylesheet you want-->
<link type="text/css" rel="stylesheet" href="style.css">

<title>Azureus Stats Interpreter</title>
<body>
<CENTER>
<font size="+2"><A HREF="http://azureus.sourceforge.net/">Azureus</A> Stats</font><BR>
<font size="-2">(from <%=inputFile%>)</font>
</CENTER>
<P>
<CENTER>
<TABLE border=1 width=80%>
<TR>
    <TD><B>Name</B></TD>
    <TD><CENTER><B>Percent Done</B></CENTER></TD>
    <TD><CENTER><B>Download Status</B></CENTER></TD>
    <TD><B>Tracker Status</B></TD>
</TR>
<%=getTableText(inputFile)%>
</TABLE>
</CENTER>
<P>
<BR>
<center><font size="-2" face="Arial">2004 <A HREF="http://pipasoft.com">Pipasoft.com</A>. All rights reserved.</font></center>


</body></html>


<%!
    /**
    *  version 1.0 released 9/26/04
    **/

    /**
    * Java code starts here. Yes, I know you shouldn't have Java code in a JSP.
    * Yes, I know usingXML transofrmation via XSLT would have been easier. But...
    * I wanted a single JSP with no additional .jars, classes
    *
    * After writing this code, I truly appreciate what an XML parser does for you
    *
    * @param inputFile the Azureus XML file to parse
    **/

    public static String getTableText(String inputFile){
        try {
            StringBuffer sb = new StringBuffer();
            String contents = getFileContents(inputFile);
            if (contents.indexOf("<DOWNLOADS>") == -1) {
                throw new Exception("File at "+inputFile+" is not a valid Azureus Stats file");
            }
            int[] locations = getDownloadLocations(contents);
            for (int i = 0; i<locations.length; i++){
                String partialContents = contents.substring(locations[i]+10, contents.length());
                String oneLine = getOneLine(partialContents);
                sb.append(oneLine);
            }
            return sb.toString();
        }
        catch (Exception e){
            e.printStackTrace();
            return "<B>"+e.getMessage()+"</B>";
        }
    }
    /**
    *  given a filename, gets the entire contents of the file
    * the file can be local or a URL
    *
    * @param filename the file to load and retrve it
    * @return the String contents of the file
    **/
    public static String getFileContents(String filename) throws Exception{
        if (filename.startsWith("http:") || filename.startsWith("ftp:"))
            return getURLFileContents(filename);
        else
            return getLocalFileContents(filename);
    }

    /**
    *  given a local filename, gets the entire contents of the file
    *
    * @param filename the file to load and get the contents from
    * @return the String contents of the file
    **/
    private static String getLocalFileContents(String filename) throws Exception{
        try {
            BufferedReader in = new BufferedReader(new FileReader(filename));
            return readFromReader(in);
        }
        catch (Exception e) {
            throw new Exception("File error - unable to load " +filename);
        }
    }

    /**
    *  given a URL, gets the entire contents of the file
    *
    * @param url the url to load and get the contents from
    * @return the String contents of the file
    **/
    private static String getURLFileContents(String url) throws Exception{
        try {
            //grab the file
            URL gotoUrl = new URL(url);
            InputStreamReader isr = new InputStreamReader(gotoUrl.openStream());
            BufferedReader in = new BufferedReader(isr);
            return readFromReader(in);
        }
        catch (Exception e){
            throw new Exception("Could not load file from "+url);
        }
    }

    /**
    *  Reads all contents of a reader and returns it as a string
    *
    * @param in the reader
    * @return the String contents of the reader
    **/
    private static String readFromReader(BufferedReader in) throws Exception{
        StringBuffer sb = new StringBuffer();
        String inputLine;

        //read each line
        while ((inputLine = in.readLine()) != null){
            String singleLine = inputLine.trim();
            if (!singleLine.equals(""))
                sb.append(inputLine+"\n");
        }
        in.close();
        return sb.toString();
    }

    /**
    *  Returns the positions in the file of the <DOWNLOAD> tags
    *
    * @xml the Azureus stats xml contents
    * @return an int[] of download positions
    **/
    private static int[] getDownloadLocations(String xml){
        ArrayList list = new ArrayList();
        String DOWNLOAD = "<DOWNLOAD>";
        int location = -1;
        int count = 0;
        int addOn = 0;
        while (true){
            location = xml.indexOf(DOWNLOAD);
            if(location != -1){
                int realLoc = location+addOn;
                //System.out.println("loc:"+realLoc);
                list.add(new Integer(realLoc));
                addOn = addOn+xml.substring(0, location+10).length();
                xml = xml.substring(location+10, xml.length());
            }
            else{
                int[] array = new int[list.size()];
                for (int i = 0; i<list.size(); i++) {
                    array[i]=((Integer)list.get(i)).intValue();
                }
                return array;
            }
        }
    }

    /**
    *  Gets one interpreted HTML line from the Azureus XML file.
    * If you want different info in your table, edit this
    *
    * @contents the Azureus stats xml contents
    * @return a single HTML line for the table
    **/
    private static String getOneLine(String contents){
        StringBuffer sb = new StringBuffer();
        String name = getValue("NAME", contents);
        String completed = getValue("COMPLETED",contents);
        if (completed.length() >1) {
            completed=completed.substring(0,completed.length()-1)+"%";
        }
        String status = getValue("DOWNLOAD_STATUS",contents);
          String tStatus = getValue("TRACKER_STATUS",contents);
        sb.append("<TR>");
        sb.append("<TD>"+name+"</TD>");
        sb.append("<TD><CENTER>"+completed+"</CENTER></TD>");
        sb.append("<TD><CENTER>"+status+"</CENTER></TD>");
        sb.append("<TD>"+tStatus+"</TD>");
        sb.append("</TR>");
        return sb.toString();
    }

    /**
    *  Gets a single value out of an XML fragment
    *
    * @key the name of the value you want. This corresponds to values
    * in the XML file like NAME, PIECE_COUNT, etc.
    * @text the xml frament to parse
    * @return the value of the single key
    **/
    public static String getValue(String key, String text){
        String start = "<"+key+">";
        String end = "</"+key+">";
        int nameLength = start.length();
        int location = text.indexOf(start);
        if (location == -1)
            return null;

        int endLocation = text.indexOf("</"+key+">");
        if (endLocation == -1)
            return text.substring(location+nameLength, text.length());
        else
            return text.substring(location+nameLength, endLocation);
    }

%>